#include "gadgets.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

uint32_t
find_gadget_candidate(
                      char** alternatives,
                      size_t gadget_length)
{
  void* haystack_start = (void*)atoi;    // will do...
  size_t haystack_size = 100*1024*1024;  // likewise...
  
  for (char* candidate = *alternatives; candidate != NULL; alternatives++) {
    void* found_at = memmem(haystack_start, haystack_size, candidate, gadget_length);
    if (found_at != NULL){
      printf("found at: %x\n", (uint32_t)found_at);
      return (uint32_t)found_at;
    }
  }
  
  return 0;
}